> ## Documentation Index
> Fetch the complete documentation index at: https://docs.usenash.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Add Custom Event to Order

> Adds a customizable event to an existing Nash order. Custom order events will be shown in the order events page alongside other Nash-generated events.

<Info>
  ### Limits

  * **Rate limits:** Max 3 requests/second
  * **Size limit:** Request body must not exceed 1kb
</Info>


## OpenAPI

````yaml post /v1/order/{id}/events
openapi: 3.1.0
info:
  title: Nash API
  version: 1.0.0
servers:
  - url: https://api.sandbox.usenash.com
    description: Sandbox API
  - url: https://api.sandbox.ap-southeast-2.usenash.com
    description: Sandbox API (Australia)
  - url: https://api.usenash.com
    description: Production API
  - url: https://api.ap-southeast-2.usenash.com
    description: Production API (Australia)
security: []
tags:
  - name: Notifications
    description: Notifications
    x-nash-topic: config
  - name: Annotate
    description: Annotate
    x-nash-topic: wismo
  - name: Notifications — Send
    description: One-off notification send without a NotificationTrigger.
    x-nash-topic: notifications
  - name: Shipping
    description: Shipping operations
    x-nash-topic: shipping
  - name: Workflow
    description: Workflow automation management
    x-nash-topic: scheduling
  - name: Workflow Execution
    description: Workflow execution history and monitoring
    x-nash-topic: scheduling
  - name: Optimization Strategies
    description: Create, read, update, and delete route optimization strategies.
    x-nash-topic: scheduling
  - name: AI Agents
    description: AI agent management — create, read, update, and delete agents
    x-nash-topic: config
  - name: AI Functions
    description: LLM-backed domain tools
    x-nash-topic: ai
  - name: Webhooks
    description: Webhook delivery inspection
    x-nash-topic: webhooks
  - name: Fleet Simulator
    description: Simulate delivery status transitions in dev and sandbox environments.
    x-nash-topic: testing
  - name: Miscellaneous
    description: Miscellaneous
  - name: Job
    description: Job
    x-nash-topic: wismo
  - name: Batch Job
    description: Batch Job
    x-nash-topic: wismo
  - name: Order
    description: Order
    x-nash-topic: wismo
  - name: Route
    description: Route
    x-nash-topic: scheduling
  - name: Provider
    description: Provider
    x-nash-topic: provider
  - name: Dispatch Strategies
    description: Dispatch Strategies
    x-nash-topic: scheduling
  - name: Store Locations
    description: Store Locations
    x-nash-topic: config
  - name: Vehicles
    description: Vehicles
    x-nash-topic: provider
  - name: Couriers
    description: Couriers
    x-nash-topic: provider
  - name: Shifts
    description: Shifts
    x-nash-topic: provider
  - name: Delivery Windows
    description: Delivery Windows
    x-nash-topic: config
  - name: Templates
    description: Templates
    x-nash-topic: config
  - name: Zones
    description: Zones
    x-nash-topic: config
  - name: Feedback
    description: Feedback
    x-nash-topic: reporting
  - name: Organizations
    description: Organizations
    x-nash-topic: config
  - name: Store Catalog
    description: Store Catalog
    x-nash-topic: config
  - name: Messaging
    description: Messaging
    x-nash-topic: config
  - name: Contracts
    description: Provider contract pricing and version listings
    x-nash-topic: provider
  - name: Event Timeline
    description: Entity-scoped event timeline + outbound provider traffic for one entity.
    x-nash-topic: internal
  - name: Fleet
    description: Inbound endpoints fleets call to update in-flight deliveries.
    x-nash-topic: delivery
  - name: Route Restrictions
    description: Org-scoped geographic areas the route optimizer must avoid traversing.
    x-nash-topic: config
  - name: Users
    description: User, role, and organization-membership management.
    x-nash-topic: config
paths:
  /v1/order/{id}/events:
    post:
      tags:
        - Order
      summary: Add custom event to order
      description: >-
        Add a custom event to an order's event timeline. Rate limited to 3
        requests per second per order with a max payload of 1KB.
      operationId: add_order_event_v1_order__string_id__events_post
      parameters:
        - name: id
          in: path
          description: >-
            Unique reference number for the order: either order.id (starts with
            "ord_") or order.externalId
          required: true
          schema:
            title: Id
            type: string
            description: >-
              Unique reference number for the order: either order.id (starts
              with "ord_") or order.externalId
            example: ord_1234567890
          example: ord_1234567890
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/AddEventInputSerializer'
        required: true
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/AddEventOutputSerializer'
        '422':
          description: Unprocessable Content
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/NashValidationError'
components:
  schemas:
    AddEventInputSerializer:
      title: AddEventInputSerializer
      required:
        - name
      type: object
      properties:
        name:
          title: Name
          type: string
        timestamp:
          title: Timestamp
          anyOf:
            - pattern: (\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):(\d{2}).?(\d)*Z?
              type: string
            - type: 'null'
          description: The event time in UTC in the form 'YYYY-MM-DDTHH:MM:SSZ'.
          default: null
        payload:
          title: Payload
          anyOf:
            - type: object
              additionalProperties: true
            - type: 'null'
          default: null
      description: Expected payload for the add event endpoint.
    AddEventOutputSerializer:
      title: AddEventOutputSerializer
      required:
        - event
      type: object
      properties:
        event:
          $ref: '#/components/schemas/EventOutputPayload'
    NashValidationError:
      title: NashValidationError
      required:
        - error
        - response_status
        - RequestID
      type: object
      properties:
        error:
          $ref: '#/components/schemas/NashErrorDetails'
        response_status:
          title: Response Status
          type: string
        RequestID:
          title: Requestid
          type: string
    EventOutputPayload:
      title: EventOutputPayload
      required:
        - id
        - eventName
        - orderId
        - eventCreatedAt
      type: object
      properties:
        id:
          title: Id
          type: string
        eventName:
          title: Eventname
          type: string
        orderId:
          title: Orderid
          type: string
        payload:
          title: Payload
          anyOf:
            - type: object
              additionalProperties: true
            - type: 'null'
          default: null
        eventCreatedAt:
          title: Eventcreatedat
          type: string
    NashErrorDetails:
      title: NashErrorDetails
      required:
        - code
        - message
      type: object
      properties:
        code:
          title: Code
          type: string
        message:
          title: Message
          type: string
        details:
          title: Details
          anyOf:
            - type: object
              additionalProperties: true
            - type: 'null'
          default: null

````